'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _bluebird = require('bluebird');

var _bluebird2 = _interopRequireDefault(_bluebird);

var _client = require('./client');

var _client2 = _interopRequireDefault(_client);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var API = function () {
  _createClass(API, null, [{
    key: 'mixin',
    value: function mixin(obj) {
      for (var key in obj) {
        if (API.apis.hasOwnProperty(key)) {
          throw new Error('Don\'t allow override existed prototype method. method: ' + key);
        }
        API.apis[key] = obj[key];
      }
    }
  }]);

  function API(getToken, saveToken) {
    var _this = this;

    _classCallCheck(this, API);

    this.authClient = new _client2.default(1);
    this.apiClient = new _client2.default(2);

    this.store = {};
    this.getTokenExt = getToken || function (uid, next) {
      var token = _this.store[uid];
      if (token) {
        next(null, token);
      } else {
        next(new Error('No token for ' + uid + ', please authorize first.'), token);
      }
    };

    this.saveTokenExt = saveToken || function (uid, token, next) {
      _this.store[uid] = token;
      next(null);
    };

    Object.keys(API.apis).forEach(function (key) {
      _this[key] = API.apis[key].bind(_this);
    });
  }

  _createClass(API, [{
    key: 'getToken',
    value: function getToken(uid) {
      var _this2 = this;

      return new _bluebird2.default(function (resolve, reject) {
        _this2.getTokenExt(uid, function (err, token) {
          if (err) {
            reject(err);
          } else {
            resolve(token);
          }
        });
      });
    }
  }, {
    key: 'saveToken',
    value: function saveToken(uid, token) {
      var _this3 = this;

      return new _bluebird2.default(function (resolve, reject) {
        _this3.saveTokenExt(uid, token, function (err) {
          if (err) {
            reject(err);
          } else {
            resolve({ uid: uid, token: token });
          }
        });
      });
    }
  }]);

  return API;
}();

API.apis = {};
exports.default = API;